#!/usr/bin/env python
# coding: utf-8

# In[ ]:


import tkinter as tk
import tkinter.messagebox as box
from tkinter import filedialog
from tkinter import ttk
import itkdb
from glob import glob
from strip_test_uploader import upload
#from strip_stage_updater import set_hybrid_stage
from strip_stage_updater_2 import set_hybrid_stage


def db_interface():
    #global variables from function access

    #global variables from function access
    db_password1 = None
    db_password2 = None
    client = None

    
    app = tk.Tk()
    app.title('User Interface')

    
    
    #bring window to top and make active
    app.lift()
    app.focus_force()
    app.grab_set()
    app.grab_release()
        
    
    label_head = tk.Label(app, text='Database Interface', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    label_head.pack(padx = 10, pady = 10)
    
    
    #####Password verification
    
    
    label_pw = tk.Label(app, text='Please enter database passwords and press button first.'
                        , wraplength=300 ,width=40, justify='left', bg='yellow') 
    label_pw.pack(padx = 10, pady = 10)
    
    frame_pw1 = tk.Frame(app)
    frame_pw1.pack()
    label_pw1 = tk.Label(frame_pw1, text='Access Code 1: ')
    label_pw1.pack(side = tk.LEFT, padx = 10, pady = 10)
    entry_pw1 = tk.Entry(frame_pw1)
    entry_pw1['show'] = '*'
    entry_pw1.pack(side = tk.RIGHT, padx = 10, pady = 10)


    frame_pw2 = tk.Frame(app)
    frame_pw2.pack()
    label_pw2 = tk.Label(frame_pw2, text='Access Code 2: ')
    label_pw2.pack(side = tk.LEFT, padx = 10, pady = 10)
    entry_pw2 = tk.Entry(frame_pw2)
    entry_pw2['show'] = '*'
    entry_pw2.pack(side = tk.RIGHT, padx = 10, pady = 10)




    def pw_read():
        global db_password1, db_password2, client
        db_password1 = entry_pw1.get()
        db_password2 = entry_pw2.get()
        if db_password1 and db_password2 :
            box.showinfo( 'Confirmation', 'Received Passwords' )
            try:
                u = itkdb.core.User(accessCode1=db_password1, accessCode2=db_password2)
                client = itkdb.Client(user = u)
                client.user.authenticate()
                user = client.get('getUser', json={'userIdentity': client.user.identity})
                box.showinfo( 'Success', 'Hello {} {}, \nwelcome to the ITk database'                             .format(user["firstName"], user["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                button.configure({'background': 'lime'})
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                entry_pw1.delete(0,'end')
                entry_pw2.delete(0,'end')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
        else: 
            box.showwarning( 'Warning', 'Please Enter Passwords' )
            entry_pw1.configure({'background': 'yellow'})
            entry_pw2.configure({'background': 'yellow'}) 


    button = tk.Button(app, text='Get Password', width=25, command = pw_read, bg='yellow' )
    button.pack(padx = 10, pady = 10)
    
    
    
    #####Json File Upload
    
    
    def read_json_file():
        global db_password1, db_password2, client
        if db_password1 and db_password2 :
            json_filename =  filedialog.askopenfilename(initialdir = "./",                                           title = "Select file",filetypes = (("json files","*.json"),("all files","*.*")))
            if json_filename == '':
                box.showerror( 'Error', 'No file selected.' )
                return
            upload(client, json_filename, 'S')
        else:
            box.showwarning( 'Warning', 'Please Get Passwords first.' )


    def read_json_directory():
        global db_password1, db_password2, client
        if db_password1 and db_password2 :
            json_directory = filedialog.askdirectory(initialdir = "./",title = "Select Directory")
            if json_directory == '':
                box.showerror( 'Error', 'No directory selected.' )
                return
            files = glob(f"{json_directory}/*.json")
            if not files:
                sys.exit(f"ERROR: No json files found in dir {json_directory}")
            for f in files:
                print(f">>> Uploading {f} ...")
                upload(client, f, 'S')
        else:
            box.showwarning( 'Warning', 'Please Get Passwords first.' )



    labe00 = tk.Label(app, text='Json Upload', bg='deepskyblue', fg='black', font=('Arial Black', 10))
    labe00.pack(padx = 10, pady = 10)
    
    label000_text='Script for uploading a test json file to the database.\n    Single json file or Directory with json files.'
    labe000 = tk.Label(app, text=label000_text, wraplength=300 ,width=40, justify='left') 
    labe000.pack(padx = 10, pady = 10)
            

    frame_json = tk.Frame(app)
    frame_json.pack()  

    file_button = tk.Button(frame_json, text='Upload json File', width = 20, command = read_json_file )
    file_button.pack(side = tk.LEFT, padx = 10, pady = 10)

    dir_button = tk.Button(frame_json, text='Upload json Directory', width = 20, command = read_json_directory )
    dir_button.pack( side= tk.RIGHT, padx = 10, pady = 10)
    
    
    
    
    #####Stage Transition
    
    
    
    labe01 = tk.Label(app, text='Stage Transition', bg='deepskyblue', fg='black', font=('Arial Black', 10))
    labe01.pack(padx = 10, pady = 10)
    label10_text='Script for stage transition of parts with (or without) children.\n     Either use single serial number of provide file    with multiple serial numbers'
    label0 = tk.Label(app, text=label10_text, wraplength=300 ,width=40, justify='left') 
    label0.pack(padx = 10, pady = 10)
    
    
    
    
    frame_sn = tk.Frame(app)
    frame_sn.pack()
    label1 = tk.Label(frame_sn, text='Database ID: ', width = 15)
    label1.pack(side = tk.LEFT, padx = 10, pady = 10)
    entry1 = tk.Entry(frame_sn)
    entry1.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    frame_altID = tk.Frame(app)
    frame_altID.pack()
    label_altID = tk.Label(frame_altID, text='Alternative ID: ', width = 15)
    label_altID.pack(side = tk.LEFT, padx = 10, pady = 10)
    altID = tk.IntVar()
    radio_1 = tk.Radiobutton (frame_altID, text='False', variable = altID, value = 0)
    radio_2 = tk.Radiobutton (frame_altID, text='True', variable = altID, value = 1)
    radio_1.select()
    radio_2.pack( side = tk.RIGHT )
    radio_1.pack( side = tk.RIGHT )
    
    
    frame_nstage = tk.Frame(app)
    frame_nstage.pack()
    label2 = tk.Label(frame_nstage, text='New Stage: ', width = 15)
    label2.pack(side = tk.LEFT, padx = 10, pady = 10)
    #entry2 = tk.Entry(frame_nstage)
    #entry2.pack(side = tk.RIGHT, padx = 10, pady = 10)
    entry_stage = ttk.Combobox(frame_nstage, width = 30)
    entry_stage['values'] = ( '===Flex Arrays & Hybrid Flex==='
                             'FROM_MANUFACTURER',
                             'READY_FOR_SMD_ATTACHMENT',
                             'SMD_ATTACHMENT',
                             'SMD_POPULATED',
                             'SMD_COMPLETED',
                             'AT_HYBRID_ASSEMBLY_SITE',
                             'FAILED',
                             'USED',
                             '===Test Coupons===',
                             'AFTER_REFLOW',
                             'QA',
                             'FAILED',
                             'TESTED')
    entry_stage.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    
    
    def stage_single():
        global db_password1, db_password2, client
        n_alt_ID = bool( altID.get() )
        if db_password1 and db_password2 :
            serial_number = entry1.get()
            new_stage = entry_stage.get()
            if serial_number and new_stage :
                set_hybrid_stage(client, serial_number, n_alt_ID, new_stage)
                box.showinfo( 'Stage Transition', 'Stage Transition Completed.' )
            else:
                box.showwarning( 'Warning', 'Please Enter a Serial Number and a new Stage.' )
        else:
            box.showwarning( 'Warning', 'Please Get Passwords first.' )
    
    
    def stage_file():
        global db_password1, db_password2, client
        n_alt_ID = bool( altID.get() )
        if db_password1 and db_password2 :
            component_filename =  filedialog.askopenfilename(initialdir = "./",                                           title = "Select file",filetypes = (("text files","*.txt"),("all files","*.*")))
            new_stage = entry_stage.get()
            with open(component_filename) as file:
                for serial_number in file:
                    if serial_number and new_stage :
                        set_hybrid_stage(client, serial_number, n_alt_ID, new_stage)
                        box.showinfo( 'Stage Transition', 'Stage Transition Completed.' )
                    else:
                        box.showwarning( 'Warning', 'Please Enter a Serial Number and a new Stage.' )
        else:
            box.showwarning( 'Warning', 'Please Get Passwords first.' )
        
        
        
    
    
    frame_stage = tk.Frame(app)
    frame_stage.pack()  

    file_button = tk.Button(frame_stage, text='Single Object', width = 20, command = stage_single )
    file_button.pack(side = tk.LEFT, padx = 10, pady = 10)

    dir_button = tk.Button(frame_stage, text='File', width = 20, command = stage_file )
    dir_button.pack( side= tk.RIGHT, padx = 10, pady = 10)
    
    
    
    
    
    
    
    
    def close_window():
        app.destroy()
        global db_password1, db_password2, client
        client = None
        db_password1 = None   #delete password when window is closed
        db_password2 = None   #delete password whwn window is closed


    exit_button = tk.Button(app, text='Close', width=25, command=close_window, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)
    
    
    
    
    app.mainloop()

if __name__ == "__main__":
    db_interface()


# In[ ]:




