#!/usr/bin/env python
# coding: utf-8

# In[ ]:


import tkinter as tk
import tkinter.messagebox as box
from tkinter import filedialog
import pull_test_reader as pr
from glob import glob


def pull_popup():

    #global variables from function access
    n_db_ID = None
    n_alt_ID = False
    n_component_type = None
    n_component_stage = None
    n_run_number = 1
    out_filename = None
    
    
    app = tk.Tk()
    
    #bring appdow to top and make active
    app.lift()
    app.focus_force()
    app.grab_set()
    app.grab_release()
   
    app.title('Pull Test Interface')

    label0 = tk.Label(app, text='Pull Test Analysis', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    label0.pack(padx = 10, pady = 10)


    
    #entries for all DB related stuff
  
    
    frame_line1 = tk.Frame(app)
    frame_line1.pack()
    label1 = tk.Label(frame_line1, text='Database ID: ', width = 15 )
    label1.pack(side = tk.LEFT, padx = 10, pady = 10)
    entry1 = tk.Entry(frame_line1)
    entry1.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
   
    
    frame_line1a = tk.Frame(app)
    frame_line1a.pack()
    label1a = tk.Label(frame_line1a, text='Alternative ID: ', width = 15)
    label1a.pack(side = tk.LEFT, padx = 10, pady = 10)
    altID = tk.BooleanVar()
    radio_1 = tk.Radiobutton (frame_line1a, text='False', variable = altID, value = False)
    radio_2 = tk.Radiobutton (frame_line1a, text='True', variable = altID, value = True)
    radio_1.select()
    radio_2.pack( side = tk.RIGHT )
    radio_1.pack( side = tk.RIGHT )
    
    
    
    frame_line2 = tk.Frame(app)
    frame_line2.pack()
    label2 = tk.Label(frame_line2, text='Component Type: ', width = 15)
    label2.pack(side = tk.LEFT, padx = 10, pady = 10)
    entry2 = tk.Entry(frame_line2)
    entry2.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    frame_line3 = tk.Frame(app)
    frame_line3.pack()
    label3 = tk.Label(frame_line3, text='Component Stage: ', width = 15)
    label3.pack(side = tk.LEFT, padx = 10, pady = 10)
    entry3 = tk.Entry(frame_line3)
    entry3.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    frame_line4 = tk.Frame(app)
    frame_line4.pack()
    label4 = tk.Label(frame_line4, text='Run Number: ', width = 15)
    label4.pack(side = tk.LEFT, padx = 10, pady = 10)
    entry4 = tk.Entry(frame_line4)
    entry4.insert(tk.END, '1')
    entry4.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    frame_line5 = tk.Frame(app)
    frame_line5.pack()
    label5 = tk.Label(frame_line5, text='Output File Name: ', width = 15)
    label5.pack(side = tk.LEFT, padx = 10, pady = 10)
    entry5 = tk.Entry(frame_line5)
    entry5.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    frame_line6 = tk.Frame(app)
    frame_line6.pack()
    label6 = tk.Label(frame_line6, text='For direcotry:\n increment Run Number? ', width = 20)
    label6.pack(side = tk.LEFT, padx = 10, pady = 10)
    increase_run_number = tk.BooleanVar()
    radio_rn_F = tk.Radiobutton (frame_line6, text='No', variable = increase_run_number, value = False)
    radio_rn_T = tk.Radiobutton (frame_line6, text='Yes', variable = increase_run_number, value = True)
    radio_rn_F.select()
    radio_rn_F.pack( side = tk.RIGHT )
    radio_rn_T.pack( side = tk.RIGHT )
    
    
    
    
    def get_parameters():
        global n_db_ID, n_component_type, n_component_stage, n_run_number, out_filename, n_alt_ID
        n_db_ID = entry1.get()
        n_component_type = entry2.get()
        n_component_stage = entry3.get()
        n_run_number = entry4.get()
        out_filename = entry5.get()
        n_alt_ID = altID.get() 
        entry1.configure({'background': 'lime'})
        entry2.configure({'background': 'lime'})
        entry3.configure({'background': 'lime'})
        entry4.configure({'background': 'lime'})
        entry5.configure({'background': 'lime'})
        #print("alt ID ", n_alt_ID)
        #print("out file name", out_filename)
    
    
    
    
    
    def clear_parameters():
        global n_db_ID, n_component_type, n_component_stage, n_run_number, n_alt_ID
        #print("Old DB ID ", n_db_ID)
        n_db_ID, n_component_type, n_component_stage, n_run_number, n_alt_ID = None, None, None, 1, False
        entry1.delete(0,'end')
        entry2.delete(0,'end')
        entry3.delete(0,'end')
        entry4.delete(0,'end')
        entry4.insert(tk.END, '1')
        entry5.delete(0,'end')
        radio_1.select()
        entry1.configure({'background': 'white'})
        entry2.configure({'background': 'white'})
        entry3.configure({'background': 'white'})
        entry4.configure({'background': 'white'})
        entry5.configure({'background': 'white'})
        #print("New DB ID ", n_db_ID)
    
    
    
    frame_parameter = tk.Frame(app)
    frame_parameter.pack()
    
    button = tk.Button(frame_parameter, text='Get Parameters', width=20, command = get_parameters )
    button.pack(side = tk.LEFT, padx = 10, pady = 10)
    
    button = tk.Button(frame_parameter, text='Clear Parameters', width=20, command = clear_parameters )
    button.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    
    
    def read_pull_file():
        global n_db_ID, n_component_type, n_component_stage, n_run_number, n_alt_ID
        csv_filename =  filedialog.askopenfilename(initialdir = "./",                                          title = "Select file",filetypes = (("csv files","*.csv"),("all files","*.*")))
        if csv_filename == '':
            box.showerror( 'Error', 'No file selected.' )
            return
        
        print(f"\n>>> Analysing {csv_filename} ...") 
        pr.analyse(csv_filename, n_db_ID, n_alt_ID, n_component_type, n_component_stage, int(n_run_number), out_filename)
        box.showinfo( 'Pull Test Analysis', 'Pull Test Analysis Completed.' )
    
    
    def read_pull_directory():
        global n_db_ID, n_component_type, n_component_stage, n_run_number, n_alt_ID
        out_filename = None  #don't use set output filename since it would be overwritten for all files
        
        csv_directory = filedialog.askdirectory(initialdir = "./",title = "Select Directory")
        
        if csv_directory == '':
            box.showerror( 'Error', 'No directory selected.' )
            return
        
        #print( 'Increase run number: ', increase_run_number.get() )
        
        files = glob(f"{csv_directory}/*.csv")
        r_n = int(n_run_number)
        if not files:
            sys.exit(f"ERROR: No csv files found in directory {args.csv}")
        for f in files:
            print(f"\n>>> Analysing {f} ...")        
            pr.analyse(f, n_db_ID, n_alt_ID, n_component_type, n_component_stage, r_n, out_filename)
            if increase_run_number.get()== True : r_n += 1
        box.showinfo( 'Pull Test Analysis', 'Pull Test Analysis Completed.' )
    
    
    frame_pull = tk.Frame(app)
    frame_pull.pack()
    
    
    file_button = tk.Button(frame_pull, text='Analyse single file', width = 20, command = read_pull_file )
    file_button.pack(side = tk.LEFT, padx = 10, pady = 10)

    dir_button = tk.Button(frame_pull, text='Analyse all files in directory', width = 20, command = read_pull_directory )
    dir_button.pack( side= tk.RIGHT, padx = 10, pady = 10)
    
    
  

    exit_button = tk.Button(app, text='Close', width=25, command=app.destroy, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)

    
    clear_parameters()  #to stop the program from failing because the global variables are not recognized
    app.mainloop()


    
    
if __name__ == "__main__":
    pull_popup()


# In[ ]:




