#!/usr/bin/env python
# coding: utf-8

# In[ ]:


import tkinter as tk
from tkinter import ttk
from tkinter import filedialog
import tkinter.messagebox as box
from glob import glob
from datetime import datetime, timezone
import json

def visualinspection_popup():
    
    
    
    
    app = tk.Tk()
    
    #bring appdow to top and make active
    app.lift()
    app.focus_force()
    app.grab_set()
    app.grab_release()
   
    app.title('Visual Inspection Interface')
    
    labelTitle = tk.Label(app, text='Visual Inspection', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    labelTitle.pack(padx = 10, pady = 10)

    
    
    
    
    
    
    frame_line1 = tk.Frame(app)
    frame_line1.pack()
    compnameLabel = tk.Label(frame_line1, text='Database ID: ', width = 15 )
    compnameLabel.pack(side = tk.LEFT, padx = 10, pady = 10)
    componentName = tk.StringVar()
    compname = tk.Entry(frame_line1, textvariable = componentName)
    compname.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    frame_line2 = tk.Frame(app)
    frame_line2.pack()
    altIdLabel = tk.Label(frame_line2, text='Alternative ID?', width = 15 )
    altIdLabel.pack( side=tk.LEFT, padx=10, pady=10)
    altID = tk.BooleanVar()
    radio_alt_no = tk.Radiobutton (frame_line2, text='False', variable = altID, value = False)
    radio_alt_yes = tk.Radiobutton (frame_line2, text='True', variable = altID, value = True)
    radio_alt_yes.select()
    radio_alt_no.pack( side = tk.RIGHT )
    radio_alt_yes.pack( side = tk.RIGHT )
    
    
    frame_line3 = tk.Frame(app)
    frame_line3.pack()
    compTypeLabel = tk.Label(frame_line3, text='Component Type: ', width = 15 )
    compTypeLabel.pack( side=tk.LEFT, padx=10, pady=10 )
    componentType = ttk.Combobox(frame_line3, width = 30)
    componentType['values'] = ( 'HYBRID_FLEX',
                                'HYBRID_FLEX_ARRAY',
                                'HYBRID_FLEX_PANEL',
                                'HYBRID_ASSEMBLY',
                                'HYBRID_TEST_PANEL',
                                'MODULE' )
    componentType.pack( side=tk.RIGHT, padx=10, pady=10)
    
    
    
    
    frame_line4 = tk.Frame(app)
    frame_line4.pack()
    compStageLabel = tk.Label(frame_line4, text='Component Stage: ', width = 15 )
    compStageLabel.pack( side=tk.LEFT, padx=10, pady=10 )
    componentStage = ttk.Combobox(frame_line4, width = 30)
    componentStage['values'] = (  'FROM_MANUFACTURER',
                                  'SMD_POPULATED',
                                  'SMD_COMPLETED',
                                  'AT_HYBRID_ASSEMBLY_SITE',
                                  ' ',
                                  'ASIC_ATTACHMENT',
                                  'WIRE_BONDING',
                                  'BURN_IN',
                                  'FINISHED_HYBRID',
                                  'AT_MODULE_ASSEMBLY_SITE',
                                  ' ',
                                  'HYBRIDS_ASSEMBLED',
                                  'MANUFACTURED',
                                  ' ',
                                  'HV_TAB_ATTACHED',
                                  'GLUED',
                                  'BONDED',
                                  'TESTED',
                                  'FINISHED',
                                  'AT_LOADING_SITE' )
    componentStage.pack( side=tk.RIGHT, padx=10, pady=10)
    
    
    frame_line5 = tk.Frame(app)
    frame_line5.pack()
    testTypeLabel = tk.Label(frame_line5, text='Test Type: ', width = 15 )
    testTypeLabel.pack( side=tk.LEFT, padx=10, pady=10 )
    testType = ttk.Combobox(frame_line5, width = 30)
    testType['values'] = ( 'VISUAL_INSPECTION',
                            'VISUAL_INSPECTION_RECEPTION',
                            'VISUAL_INSPECTION_BARE',
                            'VISUAL_INSPECTION_SMD')
    testType.pack( side=tk.RIGHT, padx=10, pady=10)
    
    
    frame_line51 = tk.Frame(app)
    frame_line51.pack()
    runNumberLabel = tk.Label(frame_line51, text='Run Number: ', width = 15 )
    runNumberLabel.pack( side=tk.LEFT, padx=10, pady=10 )
    runNumber = ttk.Combobox(frame_line51, width = 5)
    runNumber['values'] = ( '1',
                            '2',
                            '3',
                            '4',
                            '5',
                            '6',
                            '7',
                            '8',
                            '9',
                            '10')
    runNumber.pack( side=tk.RIGHT, padx=10, pady=10)
    runNumber.set('1')
    
    
    
    
    
    
    frame_line6 = tk.Frame(app)
    frame_line6.pack()
    passFail = tk.Label(frame_line6, text='Test Result: ', width = 15 )
    passFail.pack( side=tk.LEFT, padx=10, pady=10)
    passed = tk.BooleanVar()
    radio_passed = tk.Radiobutton (frame_line6, text='Passed', variable = passed, value = True)
    radio_failed = tk.Radiobutton (frame_line6, text='Failed', variable = passed, value = False)
    radio_passed.select()
    radio_failed.pack( side = tk.RIGHT )
    radio_passed.pack( side = tk.RIGHT )
    
    
    
    frame_line61 = tk.Frame(app)
    frame_line61.pack()
    problemsLabel = tk.Label(frame_line61, text='Problems: ', width = 15 )
    problemsLabel.pack( side=tk.LEFT, padx=10, pady=10)
    problems = tk.BooleanVar()
    radio_prob_yes = tk.Radiobutton (frame_line61, text='Yes', variable = problems, value = True)
    radio_prob_no = tk.Radiobutton (frame_line61, text='No', variable = problems, value = False)
    radio_prob_no.select()
    radio_prob_no.pack( side = tk.RIGHT )
    radio_prob_yes.pack( side = tk.RIGHT )
    
    
    
    frame_line7 = tk.Frame(app)
    frame_line7.pack()
    commentLabel = tk.Label(frame_line7, text='Comment:', width=10)
    commentLabel.pack(side = tk.LEFT, padx=10)
    comment = tk.Text(frame_line7, width=30, height=5)
    comment.pack()
    
    
    
    
    def get_save_directory():
        saveDirectory.set( filedialog.askdirectory(initialdir = "./",title = "Select Directory") )
    
    
    frame_line8 = tk.Frame(app)
    frame_line8.pack()
    directoryLabel = tk.Label(frame_line8, text='Json saved in directory:', width=20)
    directoryLabel.pack(side = tk.LEFT, padx=10, pady=10)
    dir_button = tk.Button(frame_line8, text='Save Directory', width = 20, command = get_save_directory )
    dir_button.pack( side= tk.RIGHT, padx = 10, pady = 10)
    
    saveDirectory = tk.StringVar()
    saveDirLabel = tk.Label(app, textvariable=saveDirectory, width=60, bg='grey', wraplength=350)
    saveDirLabel.pack(padx=10, pady=10)
    
    
    
    
    def create_json():
        if componentName.get() == '' or componentType.get() == '' or componentStage.get() == ''           or testType.get() == '' or saveDirectory.get() == '':
            box.showerror( 'Error', 'Please Complete all user fields and pick a save directory.' )
        else:
            #print( componentName.get() )
            #print( 'Alternative ID: ', altID.get()  )
            #print( componentType.get() )
            #print( componentStage.get() )
            #print( testType.get() )
            #print( 'Passed: ', passed.get() )
            #print( 'Problems: ', problems.get() )
            #print( comment.get('1.0','end-1c') )
            #print( comment.get('1.0','end-1c').replace('\n', '; ').strip()   )
            #print( int( runNumber.get() )  )
            #print( saveDirectory.get() )
            
            out_dictionary = {}  ##dictionary for output
            out_dictionary.update({"componentType": componentType.get() }) 
            out_dictionary.update({"component": componentName.get() })             
            out_dictionary.update({"alternativeIdentifier": altID.get() })    
            out_dictionary.update({"currentStage": componentStage.get() })        
            out_dictionary.update({"testType" : testType.get() })
            out_dictionary.update({"institution" : "LIV"})
            out_dictionary.update({"runNumber" : int( runNumber.get() ) })                           
            out_dictionary.update({"date" : datetime.now(timezone.utc).isoformat() })      
            out_dictionary.update({"passed" : passed.get() })
            out_dictionary.update({"problems" : problems.get() })
            out_dictionary.update({"properties": None  })
            out_dictionary.update({"results" :{ "IMAGE": None } })
            out_dictionary.update({"comments" : [ comment.get('1.0','end-1c').replace('\n', '; ').strip() ] })
            
            
            
            #########save json file#######################################
    
            out_file_name = componentName.get() + '_VI_' + runNumber.get()
            out_file = saveDirectory.get() +'\\' + out_file_name + '.json'
 
            print(f"Json output file: {out_file}")
            
            with open( out_file, 'w' ) as outfile:
                json.dump(out_dictionary, outfile, indent=4)  #indent makes it human readable
    
    
    
    def clear_fields():
        compname.delete(0,'end')
        componentType.delete(0,'end')
        componentStage.delete(0,'end')
        testType.delete(0,'end')
        comment.delete('1.0','end')
        saveDirectory.set('')
    
    
    frame_button = tk.Frame(app)
    frame_button.pack()
    create_button = tk.Button(frame_button, text='Create Json', width = 25, command=create_json)
    create_button.pack(side = tk.LEFT, padx = 10, pady = 10)
    clear_button = tk.Button(frame_button, text='Clear All', width = 25, command=clear_fields)
    clear_button.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    
    
    
    exit_button = tk.Button(app, text='Close', width=25, command=app.destroy, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)


    app.mainloop()
    
    
    
    
if __name__ == "__main__":
    visualinspection_popup()


# {
# 	"componentType": "HYBRID_ASSEMBLY",
# 	"component": "LIV-X-0001",
# 	"alternativeIdentifier": true,
# 	"currentStage": "ASIC_ATTACHMENT",
# 	"testType": "VISUAL_INSPECTION",
# 	"institution": "LIV",
# 	"runNumber": 10,
# 	"date": "2021-09-08T11:30:15.3+1:00",
# 	"passed": true,
# 	"problems": false,
# 	"properties" : null,
# 	"results" : {
# 		"IMAGE" : null
# 	},
# 	"comments" : ["Comment 1", "Comment 2", "Comment 3"],
# 	"defects" : [
# 			{
# 					"name" : "defect test 1",
# 					"description" : "Not good"
# 		 },
# 		 {
# 					"name" : "defect test 2",
# 					"description" : "Even Worse"
# 		 }
# 	]
# }
